Index: src/main/resources/hippoecm-extension.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/main/resources/hippoecm-extension.xml	(revision 446)
+++ src/main/resources/hippoecm-extension.xml	(revision )
@@ -78,6 +78,12 @@
     <sv:property sv:name="hippo:contentroot" sv:type="String">
       <sv:value>/hippo:namespaces/hippogallerypicker</sv:value>
     </sv:property>
+    <sv:property sv:name="hippo:reloadonstartup" sv:type="Boolean">
+      <sv:value>true</sv:value>
+    </sv:property>
+    <sv:property sv:name="hippo:version" sv:type="String">
+      <sv:value>1.12.01</sv:value>
+    </sv:property>
   </sv:node>
 
   <sv:node sv:name="gallerypicker-image-validators">
@@ -125,30 +131,5 @@
     </sv:property>
   </sv:node>
 
-  <!--
-      Will fail in < 2.24.xx - reloadonstartup and version are not supported,
-      therefore the updater GalleryPickerUpgrader19b will remove the initialize-item
-      gallerypicker-imagelink-type, so it gets reinitialized.
-   -->
-  <sv:node sv:name="gallerypicker-imagelink-type-reloadonstartup">
-    <sv:property sv:name="jcr:primaryType" sv:type="Name">
-      <sv:value>hippo:initializeitem</sv:value>
-    </sv:property>
-    <sv:property sv:name="hippo:sequence" sv:type="Double">
-      <sv:value>10002.2</sv:value>
-    </sv:property>
-    <sv:property sv:name="hippo:contentresource" sv:type="String">
-      <sv:value>imagelink-type.xml</sv:value>
-    </sv:property>
-    <sv:property sv:name="hippo:contentroot" sv:type="String">
-      <sv:value>/hippo:namespaces/hippogallerypicker</sv:value>
-    </sv:property>
-    <sv:property sv:name="hippo:reloadonstartup" sv:type="Boolean">
-      <sv:value>true</sv:value>
-    </sv:property>
-    <sv:property sv:name="hippo:version" sv:type="String">
-      <sv:value>1.10.02</sv:value>
-    </sv:property>
-  </sv:node>
 
 </sv:node>
Index: pom.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- pom.xml	(revision 447)
+++ pom.xml	(revision )
@@ -236,23 +236,6 @@
       </plugin>
       <plugin>
         <groupId>org.apache.maven.plugins</groupId>
-        <artifactId>maven-jar-plugin</artifactId>
-        <configuration>
-          <archive>
-            <manifest>
-              <addDefaultImplementationEntries>true</addDefaultImplementationEntries>
-            </manifest>
-            <manifestEntries>
-              <Hippo-Modules>
-                org.onehippo.forge.gallerypicker.upgrade.GalleryPickerUpgrader19a
-                org.onehippo.forge.gallerypicker.upgrade.GalleryPickerUpgrader19b
-              </Hippo-Modules>
-            </manifestEntries>
-          </archive>
-        </configuration>
-      </plugin>
-      <plugin>
-        <groupId>org.apache.maven.plugins</groupId>
         <artifactId>maven-site-plugin</artifactId>
         <version>${maven.plugin.site.version}</version>
       </plugin>
Index: src/main/java/org/onehippo/forge/gallerypicker/upgrade/GalleryPickerUpgrader19b.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/main/java/org/onehippo/forge/gallerypicker/upgrade/GalleryPickerUpgrader19b.java	(revision 446)
+++ src/main/java/org/onehippo/forge/gallerypicker/upgrade/GalleryPickerUpgrader19b.java	(revision 446)
@@ -1,53 +0,0 @@
-/*
- *  Copyright 2010-2013 Hippo B.V. (http://www.onehippo.com)
- * 
- *  Licensed under the Apache License, Version 2.0 (the "License");
- *  you may not use this file except in compliance with the License.
- *  You may obtain a copy of the License at
- * 
- *       http://www.apache.org/licenses/LICENSE-2.0
- * 
- *  Unless required by applicable law or agreed to in writing, software
- *  distributed under the License is distributed on an "AS IS" BASIS,
- *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- *  See the License for the specific language governing permissions and
- *  limitations under the License.
- */
-package org.onehippo.forge.gallerypicker.upgrade;
-
-
-import javax.jcr.Node;
-import javax.jcr.RepositoryException;
-
-import org.hippoecm.repository.ext.UpdaterContext;
-import org.hippoecm.repository.ext.UpdaterItemVisitor.PathVisitor;
-import org.hippoecm.repository.ext.UpdaterModule;
-import org.slf4j.Logger;
-import org.slf4j.LoggerFactory;
-
-public class GalleryPickerUpgrader19b implements UpdaterModule {
-    static final Logger log = LoggerFactory.getLogger(GalleryPickerUpgrader19a.class);
-
-    public void register(final UpdaterContext context) {
-        context.registerName("gallerypicker-upgrade-v19b");
-        context.registerStartTag("v19a-gallerypicker");
-        context.registerEndTag("v19b-gallerypicker");
-
-        context.registerVisitor(new PathVisitor("/hippo:namespaces/hippogallerypicker") {
-            @Override
-            public void leaving(Node node, int level) throws RepositoryException {
-                if (node.hasNode("imagelink")) {
-                    node.getNode("imagelink").remove();
-                }
-            }
-        });
-        context.registerVisitor(new PathVisitor("/hippo:configuration/hippo:initialize") {
-            @Override
-            public void leaving(Node node, int level) throws RepositoryException {
-                if (node.hasNode("gallerypicker-imagelink-type")) {
-                    node.getNode("gallerypicker-imagelink-type").remove();
-                }
-            }
-        });
-    }
-}
Index: src/main/java/org/onehippo/forge/gallerypicker/upgrade/GalleryPickerUpgrader19a.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/main/java/org/onehippo/forge/gallerypicker/upgrade/GalleryPickerUpgrader19a.java	(revision 446)
+++ src/main/java/org/onehippo/forge/gallerypicker/upgrade/GalleryPickerUpgrader19a.java	(revision 446)
@@ -1,53 +0,0 @@
-/*
- *  Copyright 2010-2013 Hippo B.V. (http://www.onehippo.com)
- * 
- *  Licensed under the Apache License, Version 2.0 (the "License");
- *  you may not use this file except in compliance with the License.
- *  You may obtain a copy of the License at
- * 
- *       http://www.apache.org/licenses/LICENSE-2.0
- * 
- *  Unless required by applicable law or agreed to in writing, software
- *  distributed under the License is distributed on an "AS IS" BASIS,
- *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- *  See the License for the specific language governing permissions and
- *  limitations under the License.
- */
-package org.onehippo.forge.gallerypicker.upgrade;
-
-
-import org.hippoecm.repository.ext.UpdaterContext;
-import org.hippoecm.repository.ext.UpdaterItemVisitor.PathVisitor;
-import org.hippoecm.repository.ext.UpdaterModule;
-import org.slf4j.Logger;
-import org.slf4j.LoggerFactory;
-
-import javax.jcr.Node;
-import javax.jcr.RepositoryException;
-
-public class GalleryPickerUpgrader19a implements UpdaterModule {
-    static final Logger log = LoggerFactory.getLogger(GalleryPickerUpgrader19a.class);
-        
-    public void register(final UpdaterContext context) {
-        context.registerName("gallerypicker-upgrade-v19a");
-        context.registerStartTag("v15a-gallerypicker");
-        context.registerEndTag("v19a-gallerypicker");
-
-        context.registerVisitor(new PathVisitor("/hippo:namespaces/hippogallerypicker") {
-            @Override
-            public void leaving(Node node, int level) throws RepositoryException {
-                if (node.hasNode("imagelink")) {
-                    node.getNode("imagelink").remove();
-                }
-            }
-        });
-        context.registerVisitor(new PathVisitor("/hippo:configuration/hippo:initialize") {
-            @Override
-            public void leaving(Node node, int level) throws RepositoryException {
-                if (node.hasNode("gallerypicker-imagelink-type")) {
-                    node.getNode("gallerypicker-imagelink-type").remove();
-                }
-            }
-        });
-    }
-}