Index: addon/repository/src/main/java/org/onehippo/forge/properties/upgrade/PropertiesBaseUpdater.java
===================================================================
--- addon/repository/src/main/java/org/onehippo/forge/properties/upgrade/PropertiesBaseUpdater.java	(revision 893)
+++ addon/repository/src/main/java/org/onehippo/forge/properties/upgrade/PropertiesBaseUpdater.java	(revision 893)
@@ -1,95 +0,0 @@
-/*
- * Copyright 2011-2013 Hippo B.V. (http://www.onehippo.com)
- * 
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- * 
- *  http://www.apache.org/licenses/LICENSE-2.0
- * 
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-package org.onehippo.forge.properties.upgrade;
-
-import javax.jcr.Node;
-import javax.jcr.RepositoryException;
-
-import org.hippoecm.repository.ext.UpdaterContext;
-import org.hippoecm.repository.ext.UpdaterItemVisitor;
-import org.hippoecm.repository.ext.UpdaterModule;
-import org.slf4j.Logger;
-import org.slf4j.LoggerFactory;
-
-/**
- * Base updater module
- */
-public abstract class PropertiesBaseUpdater implements UpdaterModule  {
-    protected final static String TAG_V12A = "v12a-properties";
-    protected final static String TAG_V16A = "v16a-properties";
-    protected final static String TAG_V18A = "v18a-properties";
-
-    protected final static String NAMESPACE = "properties";
-
-    protected final static String INIT_NODE_CND = "properties";
-    protected final static String INIT_NODE_NAMESPACE = "properties-namespace";
-
-    protected static final Logger log = LoggerFactory.getLogger(PropertiesUpdater16a.class);
-
-    @Override
-    public void register(final UpdaterContext context) {
-
-        // register
-        registerTags(context);
-
-        // visit hippo:initialize
-        context.registerVisitor(new UpdaterItemVisitor.PathVisitor("/hippo:configuration/hippo:initialize") {
-            @Override
-            protected void leaving(Node node, int level) throws RepositoryException {
-                updateInitializeNode(node);
-            }
-        });
-
-        // visit hippo:namespaces
-        context.registerVisitor(new UpdaterItemVisitor.PathVisitor("/hippo:namespaces") {
-            @Override
-            protected void leaving(Node node, int level) throws RepositoryException {
-                updateNamespaces(node);
-            }
-        });
-    }
-
-    /**
-     * Register name, start tag, end tag for this updater.
-     */
-    protected void registerTags(final UpdaterContext context) {
-        // hook
-    }
-
-    /**
-     * Callback for the visitor for node /hippo:namespaces
-     */
-    protected void updateNamespaces(final Node node) throws RepositoryException {
-        // hook
-    }
-
-    /**
-     * Callback for the visitor for node /hippo:configuration/hippo:initialize
-     */
-    protected void updateInitializeNode(final Node node) throws RepositoryException {
-        // hook
-    }
-
-    /**
-     * Removes {@link Node} if it exists.
-     */
-    protected static void removeNode(Node node, String name) throws RepositoryException {
-        log.info("Removing subnode '" + name + "' from " + node.getPath() + " (exists=" + node.hasNode(name) + ")");
-        if (node.hasNode(name)) {
-            node.getNode(name).remove();
-        }
-    }
-}
Index: addon/repository/pom.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- addon/repository/pom.xml	(revision 893)
+++ addon/repository/pom.xml	(revision )
@@ -42,24 +42,5 @@
 
   <build>
     <defaultGoal>install</defaultGoal>
-    <plugins>
-      <plugin>
-        <groupId>org.apache.maven.plugins</groupId>
-        <artifactId>maven-jar-plugin</artifactId>
-        <configuration>
-          <archive>
-            <manifest>
-              <addDefaultImplementationEntries>true</addDefaultImplementationEntries>
-            </manifest>
-            <manifestEntries>
-              <Hippo-Modules>
-                org.onehippo.forge.properties.upgrade.PropertiesUpdater16a
-                org.onehippo.forge.properties.upgrade.PropertiesUpdater18a
-              </Hippo-Modules>
-            </manifestEntries>
-          </archive>
-        </configuration>
-      </plugin>
-    </plugins>
   </build>
 </project>
Index: addon/repository/src/main/resources/new-properties-document.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- addon/repository/src/main/resources/new-properties-document.xml	(revision 893)
+++ addon/repository/src/main/resources/new-properties-document.xml	(revision )
@@ -78,4 +78,18 @@
       <sv:value>document de propriétés</sv:value>
     </sv:property>
   </sv:node>
+  <sv:node sv:name="hippo:translation">
+    <sv:property sv:name="jcr:primaryType" sv:type="Name">
+      <sv:value>hippo:translation</sv:value>
+    </sv:property>
+    <sv:property sv:name="hippo:class" sv:type="String">
+      <sv:value>org.hippoecm.repository.standardworkflow.FolderWorkflow</sv:value>
+    </sv:property>
+    <sv:property sv:name="hippo:language" sv:type="String">
+      <sv:value>de</sv:value>
+    </sv:property>
+    <sv:property sv:name="hippo:message" sv:type="String">
+      <sv:value>Properties Dokument</sv:value>
+    </sv:property>
+  </sv:node>
 </sv:node>
Index: addon/repository/src/main/resources/namespace_de.xml
===================================================================
--- addon/repository/src/main/resources/namespace_de.xml	(revision 893)
+++ addon/repository/src/main/resources/namespace_de.xml	(revision 893)
@@ -1,111 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<!--
-  Copyright 2009-2013 Hippo
-
-  Licensed under the Apache License, Version 2.0 (the  "License");
-  you may not use this file except in compliance with the License.
-  You may obtain a copy of the License at
-
-  http://www.apache.org/licenses/LICENSE-2.0
-
-  Unless required by applicable law or agreed to in writing, software
-  distributed under the License is distributed on an "AS IS"
-  BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-  See the License for the specific language governing permissions and
-  limitations under the License.
--->
-<sv:node sv:name="properties" xmlns:sv="http://www.jcp.org/jcr/sv/1.0" xmlns:h="http://www.onehippo.org/jcr/xmlimport" h:merge="combine">
-
-  <sv:node sv:name="property" h:merge="combine">
-
-    <sv:node sv:name="hippo:translation">
-      <sv:property sv:name="jcr:primaryType" sv:type="Name">
-        <sv:value>hippo:translation</sv:value>
-      </sv:property>
-      <sv:property sv:name="hippo:language" sv:type="String">
-        <sv:value>de</sv:value>
-      </sv:property>
-      <sv:property sv:name="hippo:message" sv:type="String">
-        <sv:value>Eigenschaft</sv:value>
-      </sv:property>
-    </sv:node>
-
-    <sv:node sv:name="editor:templates" h:merge="combine">
-      <sv:node sv:name="_default_" h:merge="combine">
-        <sv:node sv:name="translator" h:merge="combine">
-          <sv:node sv:name="hippostd:translations" h:merge="combine">
-
-            <sv:node sv:name="name" h:merge="combine">
-              <sv:node sv:name="hippo:translation">
-                <sv:property sv:name="jcr:primaryType" sv:type="Name">
-                  <sv:value>hippo:translation</sv:value>
-                </sv:property>
-                <sv:property sv:name="hippo:language" sv:type="String">
-                  <sv:value>de</sv:value>
-                </sv:property>
-                <sv:property sv:name="hippo:message" sv:type="String">
-                  <sv:value>Name</sv:value>
-                </sv:property>
-              </sv:node>
-            </sv:node>
-
-            <sv:node sv:name="value" h:merge="combine">
-              <sv:node sv:name="hippo:translation">
-                <sv:property sv:name="jcr:primaryType" sv:type="Name">
-                  <sv:value>hippo:translation</sv:value>
-                </sv:property>
-                <sv:property sv:name="hippo:language" sv:type="String">
-                  <sv:value>de</sv:value>
-                </sv:property>
-                <sv:property sv:name="hippo:message" sv:type="String">
-                  <sv:value>Wert</sv:value>
-                </sv:property>
-              </sv:node>
-            </sv:node>
-
-          </sv:node>
-        </sv:node>
-      </sv:node>
-    </sv:node>
-  </sv:node>
-
-  <sv:node sv:name="properties" h:merge="combine">
-
-    <sv:node sv:name="hippo:translation">
-      <sv:property sv:name="jcr:primaryType" sv:type="Name">
-        <sv:value>hippo:translation</sv:value>
-      </sv:property>
-      <sv:property sv:name="hippo:language" sv:type="String">
-        <sv:value>de</sv:value>
-      </sv:property>
-      <sv:property sv:name="hippo:message" sv:type="String">
-        <sv:value>Eigenschaften</sv:value>
-      </sv:property>
-    </sv:node>
-
-    <sv:node sv:name="editor:templates" h:merge="combine">
-      <sv:node sv:name="_default_" h:merge="combine">
-        <sv:node sv:name="translator" h:merge="combine">
-          <sv:node sv:name="hippostd:translations" h:merge="combine">
-            <sv:node sv:name="property" h:merge="combine">
-
-              <sv:node sv:name="hippo:translation">
-                <sv:property sv:name="jcr:primaryType" sv:type="Name">
-                  <sv:value>hippo:translation</sv:value>
-                </sv:property>
-                <sv:property sv:name="hippo:language" sv:type="String">
-                  <sv:value>de</sv:value>
-                </sv:property>
-                <sv:property sv:name="hippo:message" sv:type="String">
-                  <sv:value>Eigenschaft</sv:value>
-                </sv:property>
-              </sv:node>
-
-            </sv:node>
-          </sv:node>
-        </sv:node>
-      </sv:node>
-    </sv:node>
-
-  </sv:node>
-</sv:node>
\ No newline at end of file
Index: addon/repository/src/main/java/org/onehippo/forge/properties/upgrade/PropertiesUpdater18a.java
===================================================================
--- addon/repository/src/main/java/org/onehippo/forge/properties/upgrade/PropertiesUpdater18a.java	(revision 893)
+++ addon/repository/src/main/java/org/onehippo/forge/properties/upgrade/PropertiesUpdater18a.java	(revision 893)
@@ -1,51 +0,0 @@
-/*
- *  Copyright 2010-2013 Hippo B.V. (http://www.onehippo.com)
- * 
- *  Licensed under the Apache License, Version 2.0 (the "License");
- *  you may not use this file except in compliance with the License.
- *  You may obtain a copy of the License at
- * 
- *       http://www.apache.org/licenses/LICENSE-2.0
- * 
- *  Unless required by applicable law or agreed to in writing, software
- *  distributed under the License is distributed on an "AS IS" BASIS,
- *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- *  See the License for the specific language governing permissions and
- *  limitations under the License.
- */
-package org.onehippo.forge.properties.upgrade;
-
-import javax.jcr.Node;
-import javax.jcr.RepositoryException;
-
-import org.hippoecm.repository.ext.UpdaterContext;
-import org.hippoecm.repository.ext.UpdaterItemVisitor;
-
-/**
- * Updater module to migrate from ECM 2.16.xx to 2.18.xx.
- *
- * Reloads cnd because of added 'orderable'.
- * Reloads namespace because of addition of hippotranslation in the prototype.
- */
-public class PropertiesUpdater18a extends PropertiesBaseUpdater {
-
-    @Override
-    protected void registerTags(final UpdaterContext context) {
-        context.registerName("properties-upgrade-v18a");
-        context.registerStartTag(TAG_V16A);
-        context.registerEndTag(TAG_V18A);
-    }
-
-    @Override
-    protected void updateNamespaces(final Node node) throws RepositoryException {
-        // remove the properties namespace, is reloaded
-        removeNode(node, NAMESPACE);
-    }
-
-    @Override
-    protected void updateInitializeNode(final Node node) throws RepositoryException {
-        // remove initializers for the cnd and properties namespace
-        removeNode(node, INIT_NODE_CND);
-        removeNode(node, INIT_NODE_NAMESPACE);
-    }
-}
Index: addon/repository/src/main/resources/namespace.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- addon/repository/src/main/resources/namespace.xml	(revision 893)
+++ addon/repository/src/main/resources/namespace.xml	(revision )
@@ -74,6 +74,17 @@
         <sv:value>proprietà</sv:value>
       </sv:property>
     </sv:node>
+    <sv:node sv:name="hippo:translation">
+      <sv:property sv:name="jcr:primaryType" sv:type="Name">
+        <sv:value>hippo:translation</sv:value>
+      </sv:property>
+      <sv:property sv:name="hippo:language" sv:type="String">
+        <sv:value>de</sv:value>
+      </sv:property>
+      <sv:property sv:name="hippo:message" sv:type="String">
+        <sv:value>Eigenschaft</sv:value>
+      </sv:property>
+    </sv:node>
     <sv:node sv:name="hipposysedit:nodetype">
       <sv:property sv:name="jcr:primaryType" sv:type="Name">
         <sv:value>hippo:handle</sv:value>
@@ -249,7 +260,18 @@
                   <sv:value>Nome</sv:value>
                 </sv:property>
               </sv:node>
+              <sv:node sv:name="hippo:translation">
+                <sv:property sv:name="jcr:primaryType" sv:type="Name">
+                  <sv:value>hippo:translation</sv:value>
+                </sv:property>
+                <sv:property sv:name="hippo:language" sv:type="String">
+                  <sv:value>de</sv:value>
+                </sv:property>
+                <sv:property sv:name="hippo:message" sv:type="String">
+                  <sv:value>Name</sv:value>
+                </sv:property>
-            </sv:node>
+              </sv:node>
+            </sv:node>
             <sv:node sv:name="value">
               <sv:property sv:name="jcr:primaryType" sv:type="Name">
                 <sv:value>frontend:plugin</sv:value>
@@ -301,9 +323,20 @@
                   <sv:value>Valore</sv:value>
                 </sv:property>
               </sv:node>
+              <sv:node sv:name="hippo:translation">
+                <sv:property sv:name="jcr:primaryType" sv:type="Name">
+                  <sv:value>hippo:translation</sv:value>
+                </sv:property>
+                <sv:property sv:name="hippo:language" sv:type="String">
+                  <sv:value>de</sv:value>
+                </sv:property>
+                <sv:property sv:name="hippo:message" sv:type="String">
+                  <sv:value>Wert</sv:value>
+                </sv:property>
-            </sv:node>
-          </sv:node>
-        </sv:node>
+              </sv:node>
+            </sv:node>
+          </sv:node>
+        </sv:node>
         <sv:node sv:name="twocolumn">
           <sv:property sv:name="jcr:primaryType" sv:type="Name">
             <sv:value>frontend:plugin</sv:value>
@@ -477,6 +510,17 @@
         <sv:value>Proprietà</sv:value>
       </sv:property>
     </sv:node>
+    <sv:node sv:name="hippo:translation">
+      <sv:property sv:name="jcr:primaryType" sv:type="Name">
+        <sv:value>hippo:translation</sv:value>
+      </sv:property>
+      <sv:property sv:name="hippo:language" sv:type="String">
+        <sv:value>de</sv:value>
+      </sv:property>
+      <sv:property sv:name="hippo:message" sv:type="String">
+        <sv:value>Eigenschaften</sv:value>
+      </sv:property>
+    </sv:node>
     <sv:node sv:name="hipposysedit:nodetype">
       <sv:property sv:name="jcr:primaryType" sv:type="Name">
         <sv:value>hippo:handle</sv:value>
@@ -670,6 +714,17 @@
                 </sv:property>
                 <sv:property sv:name="hippo:message" sv:type="String">
                   <sv:value>Proprietà</sv:value>
+                </sv:property>
+              </sv:node>
+              <sv:node sv:name="hippo:translation">
+                <sv:property sv:name="jcr:primaryType" sv:type="Name">
+                  <sv:value>hippo:translation</sv:value>
+                </sv:property>
+                <sv:property sv:name="hippo:language" sv:type="String">
+                  <sv:value>de</sv:value>
+                </sv:property>
+                <sv:property sv:name="hippo:message" sv:type="String">
+                  <sv:value>Eigenschaft</sv:value>
                 </sv:property>
               </sv:node>
             </sv:node>
\ No newline at end of file
Index: addon/repository/src/main/resources/new-properties-folder.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- addon/repository/src/main/resources/new-properties-folder.xml	(revision 893)
+++ addon/repository/src/main/resources/new-properties-folder.xml	(revision )
@@ -88,4 +88,18 @@
       <sv:value>dossier</sv:value>
     </sv:property>
   </sv:node>
+  <sv:node sv:name="hippo:translation">
+    <sv:property sv:name="jcr:primaryType" sv:type="Name">
+      <sv:value>hippo:translation</sv:value>
+    </sv:property>
+    <sv:property sv:name="hippo:class" sv:type="String">
+      <sv:value>org.hippoecm.repository.standardworkflow.FolderWorkflow</sv:value>
+    </sv:property>
+    <sv:property sv:name="hippo:language" sv:type="String">
+      <sv:value>de</sv:value>
+    </sv:property>
+    <sv:property sv:name="hippo:message" sv:type="String">
+      <sv:value>Ordner</sv:value>
+    </sv:property>
+  </sv:node>
 </sv:node>
Index: addon/repository/src/main/java/org/onehippo/forge/properties/upgrade/PropertiesUpdater16a.java
===================================================================
--- addon/repository/src/main/java/org/onehippo/forge/properties/upgrade/PropertiesUpdater16a.java	(revision 893)
+++ addon/repository/src/main/java/org/onehippo/forge/properties/upgrade/PropertiesUpdater16a.java	(revision 893)
@@ -1,64 +0,0 @@
-/*
- *  Copyright 2010-2013 Hippo B.V. (http://www.onehippo.com)
- * 
- *  Licensed under the Apache License, Version 2.0 (the "License");
- *  you may not use this file except in compliance with the License.
- *  You may obtain a copy of the License at
- * 
- *       http://www.apache.org/licenses/LICENSE-2.0
- * 
- *  Unless required by applicable law or agreed to in writing, software
- *  distributed under the License is distributed on an "AS IS" BASIS,
- *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- *  See the License for the specific language governing permissions and
- *  limitations under the License.
- */
-package org.onehippo.forge.properties.upgrade;
-
-import java.io.BufferedInputStream;
-
-import javax.jcr.Node;
-import javax.jcr.RepositoryException;
-
-import org.hippoecm.repository.ext.UpdaterContext;
-import org.hippoecm.repository.ext.UpdaterItemVisitor;
-import org.hippoecm.repository.ext.UpdaterModule;
-
-/**
- * Updater module to migrate from ECM 2.12.xx to 2.16.00
- */
-public class PropertiesUpdater16a extends PropertiesBaseUpdater {
-
-    /**
-     * Removes the (old) properties namespace
-     * @see UpdaterModule#register(UpdaterContext)
-     */
-    public void register(final UpdaterContext context) {
-
-        super.register(context);
-
-        // reload properties cnd (bumped version)
-        context.registerVisitor(new UpdaterItemVisitor.NamespaceVisitor(context, "properties", 
-                new BufferedInputStream(getClass().getClassLoader().getResourceAsStream("properties.cnd"))));
-    }
-
-    @Override
-    protected void registerTags(final UpdaterContext context) {
-        context.registerName("properties-upgrade-v16a");
-        context.registerStartTag(TAG_V12A);
-        context.registerEndTag(TAG_V16A);
-    }
-
-    @Override
-    protected void updateNamespaces(final Node node) throws RepositoryException {
-        // remove the properties namespace, is reloaded
-        removeNode(node, NAMESPACE);
-    }
-
-    @Override
-    protected void updateInitializeNode(final Node node) throws RepositoryException {
-        // remove initializers for the cnd and properties namespace
-        removeNode(node, INIT_NODE_CND);
-        removeNode(node, INIT_NODE_NAMESPACE);
-    }
-}
Index: addon/repository/src/main/resources/new-properties-document_de.xml
===================================================================
--- addon/repository/src/main/resources/new-properties-document_de.xml	(revision 893)
+++ addon/repository/src/main/resources/new-properties-document_de.xml	(revision 893)
@@ -1,19 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<sv:node xmlns:sv="http://www.jcp.org/jcr/sv/1.0" sv:name="new-properties-document" xmlns:h="http://www.onehippo.org/jcr/xmlimport" h:merge="combine">
-
-  <sv:node sv:name="hippo:translation">
-    <sv:property sv:name="jcr:primaryType" sv:type="Name">
-      <sv:value>hippo:translation</sv:value>
-    </sv:property>
-    <sv:property sv:name="hippo:class" sv:type="String">
-      <sv:value>org.hippoecm.repository.standardworkflow.FolderWorkflow</sv:value>
-    </sv:property>
-    <sv:property sv:name="hippo:language" sv:type="String">
-      <sv:value>de</sv:value>
-    </sv:property>
-    <sv:property sv:name="hippo:message" sv:type="String">
-      <sv:value>Properties Dokument</sv:value>
-    </sv:property>
-  </sv:node>
-
-</sv:node>
Index: addon/repository/src/main/resources/new-properties-folder_de.xml
===================================================================
--- addon/repository/src/main/resources/new-properties-folder_de.xml	(revision 893)
+++ addon/repository/src/main/resources/new-properties-folder_de.xml	(revision 893)
@@ -1,19 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<sv:node xmlns:sv="http://www.jcp.org/jcr/sv/1.0" sv:name="new-properties-folder" xmlns:h="http://www.onehippo.org/jcr/xmlimport" h:merge="combine">
-
-  <sv:node sv:name="hippo:translation">
-    <sv:property sv:name="jcr:primaryType" sv:type="Name">
-      <sv:value>hippo:translation</sv:value>
-    </sv:property>
-    <sv:property sv:name="hippo:class" sv:type="String">
-      <sv:value>org.hippoecm.repository.standardworkflow.FolderWorkflow</sv:value>
-    </sv:property>
-    <sv:property sv:name="hippo:language" sv:type="String">
-      <sv:value>de</sv:value>
-    </sv:property>
-    <sv:property sv:name="hippo:message" sv:type="String">
-      <sv:value>Ordner</sv:value>
-    </sv:property>
-  </sv:node>
-
-</sv:node>
Index: addon/repository/src/main/resources/hippoecm-extension.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- addon/repository/src/main/resources/hippoecm-extension.xml	(revision 893)
+++ addon/repository/src/main/resources/hippoecm-extension.xml	(revision )
@@ -51,21 +51,12 @@
     <sv:property sv:name="hippo:contentroot" sv:type="String">
       <sv:value>/hippo:namespaces</sv:value>
     </sv:property>
-  </sv:node>
-
-  <sv:node sv:name="properties-namespace-de">
-    <sv:property sv:name="jcr:primaryType" sv:type="Name">
-      <sv:value>hippo:initializeitem</sv:value>
+    <sv:property sv:name="hippo:reloadonstartup" sv:type="Boolean">
+      <sv:value>true</sv:value>
     </sv:property>
-    <sv:property sv:name="hippo:sequence" sv:type="Double">
-      <sv:value>20101.1</sv:value>
+    <sv:property sv:name="hippo:version" sv:type="String">
+      <sv:value>2.09.01</sv:value>
     </sv:property>
-    <sv:property sv:name="hippo:contentresource" sv:type="String">
-      <sv:value>namespace_de.xml</sv:value>
-    </sv:property>
-    <sv:property sv:name="hippo:contentroot" sv:type="String">
-      <sv:value>/hippo:namespaces</sv:value>
-    </sv:property>
   </sv:node>
 
   <sv:node sv:name="properties-hide-properties-namespace">
@@ -96,23 +87,15 @@
     <sv:property sv:name="hippo:contentroot" sv:type="String">
       <sv:value>/hippo:configuration/hippo:queries/hippo:templates</sv:value>
     </sv:property>
-  </sv:node>
-
-  <sv:node sv:name="properties-queries-templates-new-properties-folder-de">
-    <sv:property sv:name="jcr:primaryType" sv:type="Name">
-      <sv:value>hippo:initializeitem</sv:value>
+    <sv:property sv:name="hippo:reloadonstartup" sv:type="Boolean">
+      <sv:value>true</sv:value>
     </sv:property>
-    <sv:property sv:name="hippo:sequence" sv:type="Double">
-      <sv:value>20103.1</sv:value>
+    <sv:property sv:name="hippo:version" sv:type="String">
+      <sv:value>2.09.01</sv:value>
     </sv:property>
-    <sv:property sv:name="hippo:contentresource" sv:type="String">
-      <sv:value>new-properties-folder_de.xml</sv:value>
-    </sv:property>
-    <sv:property sv:name="hippo:contentroot" sv:type="String">
-      <sv:value>/hippo:configuration/hippo:queries/hippo:templates</sv:value>
-    </sv:property>
   </sv:node>
 
+
   <sv:node sv:name="properties-queries-templates-new-properties-document">
     <sv:property sv:name="jcr:primaryType" sv:type="Name">
       <sv:value>hippo:initializeitem</sv:value>
@@ -126,20 +109,11 @@
     <sv:property sv:name="hippo:contentroot" sv:type="String">
       <sv:value>/hippo:configuration/hippo:queries/hippo:templates</sv:value>
     </sv:property>
-  </sv:node>
-
-  <sv:node sv:name="properties-queries-templates-new-properties-document-de">
-    <sv:property sv:name="jcr:primaryType" sv:type="Name">
-      <sv:value>hippo:initializeitem</sv:value>
+    <sv:property sv:name="hippo:reloadonstartup" sv:type="Boolean">
+      <sv:value>true</sv:value>
     </sv:property>
-    <sv:property sv:name="hippo:sequence" sv:type="Double">
-      <sv:value>20104.01</sv:value>
-    </sv:property>
-    <sv:property sv:name="hippo:contentresource" sv:type="String">
-      <sv:value>new-properties-document_de.xml</sv:value>
-    </sv:property>
-    <sv:property sv:name="hippo:contentroot" sv:type="String">
-      <sv:value>/hippo:configuration/hippo:queries/hippo:templates</sv:value>
+    <sv:property sv:name="hippo:version" sv:type="String">
+      <sv:value>2.09.01</sv:value>
     </sv:property>
   </sv:node>
 