Index: components/core/src/main/resources/org/hippoecm/hst/site/container/SpringComponentManager-jcr.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- components/core/src/main/resources/org/hippoecm/hst/site/container/SpringComponentManager-jcr.xml	(revision 45515)
+++ components/core/src/main/resources/org/hippoecm/hst/site/container/SpringComponentManager-jcr.xml	(revision )
@@ -17,44 +17,76 @@
 <beans xmlns="http://www.springframework.org/schema/beans"
   xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
   xsi:schemaLocation="http://www.springframework.org/schema/beans http://www.springframework.org/schema/beans/spring-beans-3.0.xsd">
-  
+
-  <bean id="javax.jcr.Credentials.default" class="javax.jcr.SimpleCredentials">
-    <constructor-arg value="${default.repository.user.name}${repository.pool.user.name.separator}${default.repository.pool.name}"/>
+  <bean id="javax.jcr.Credentials.default"  class="org.hippoecm.hst.core.jcr.SimpleCredentialsFactoryBean">
+    <constructor-arg value="${default.repository.user.name}"/>
+    <constructor-arg value="${repository.pool.user.name.separator}"/>
+    <constructor-arg value="${default.repository.pool.name}"/>
     <constructor-arg value="${default.repository.password}"/>
+    <constructor-arg value="${repository.jvm.password.enabled}"/>
   </bean>
 
- <!-- default cred that can be used in delegating repository -->
+  <!-- default cred that can be used in delegating repository -->
-  <bean id="javax.jcr.Credentials.default.delegating" class="javax.jcr.SimpleCredentials">
+  <bean id="javax.jcr.Credentials.default.delegating"  class="org.hippoecm.hst.core.jcr.SimpleCredentialsFactoryBean">
     <constructor-arg value="${default.repository.user.name}"/>
     <constructor-arg value="${default.repository.password}"/>
+    <constructor-arg value="${repository.jvm.password.enabled}"/>
   </bean>
-  
+
-  <bean id="javax.jcr.Credentials.preview" class="javax.jcr.SimpleCredentials">
-    <constructor-arg value="${preview.repository.user.name}${repository.pool.user.name.separator}${preview.repository.pool.name}"/>
+  <bean id="javax.jcr.Credentials.preview"  class="org.hippoecm.hst.core.jcr.SimpleCredentialsFactoryBean">
+    <constructor-arg value="${preview.repository.user.name}"/>
+    <constructor-arg value="${repository.pool.user.name.separator}"/>
+    <constructor-arg value="${preview.repository.pool.name}"/>
     <constructor-arg value="${preview.repository.password}"/>
+    <constructor-arg value="${repository.jvm.password.enabled}"/>
   </bean>
 
   <!-- preview cred that can be used in delegating repository -->
-  <bean id="javax.jcr.Credentials.preview.delegating" class="javax.jcr.SimpleCredentials">
+  <bean id="javax.jcr.Credentials.preview.delegating"  class="org.hippoecm.hst.core.jcr.SimpleCredentialsFactoryBean">
     <constructor-arg value="${preview.repository.user.name}"/>
     <constructor-arg value="${preview.repository.password}"/>
+    <constructor-arg value="${repository.jvm.password.enabled}"/>
   </bean>
 
-  <bean id="javax.jcr.Credentials.writable" class="javax.jcr.SimpleCredentials">
-    <constructor-arg value="${writable.repository.user.name}${repository.pool.user.name.separator}${writable.repository.pool.name}"/>
+  <!-- writable cred that can be used in delegating repository -->
+  <bean id="javax.jcr.Credentials.writable.delegating" class="org.hippoecm.hst.core.jcr.SimpleCredentialsFactoryBean">
+    <constructor-arg value="${writable.repository.user.name}"/>
     <constructor-arg value="${writable.repository.password}"/>
+    <constructor-arg value="${repository.jvm.password.enabled}"/>
   </bean>
-  
+
-  <bean id="javax.jcr.Credentials.hstconfigreader" class="javax.jcr.SimpleCredentials">
-    <constructor-arg value="${hstconfigreader.repository.user.name}${repository.pool.user.name.separator}${hstconfigreader.repository.pool.name}"/>
+  <bean id="javax.jcr.Credentials.writable" class="org.hippoecm.hst.core.jcr.SimpleCredentialsFactoryBean">
+    <constructor-arg value="${writable.repository.user.name}"/>
+    <constructor-arg value="${repository.pool.user.name.separator}"/>
+    <constructor-arg value="${writable.repository.pool.name}"/>
+    <constructor-arg value="${writable.repository.password}"/>
+    <constructor-arg value="${repository.jvm.password.enabled}"/>
+  </bean>
+
+  <bean id="javax.jcr.Credentials.hstconfigreader" class="org.hippoecm.hst.core.jcr.SimpleCredentialsFactoryBean">
+    <constructor-arg value="${hstconfigreader.repository.user.name}"/>
+    <constructor-arg value="${repository.pool.user.name.separator}"/>
+    <constructor-arg value="${hstconfigreader.repository.pool.name}"/>
     <constructor-arg value="${hstconfigreader.repository.password}"/>
+    <constructor-arg value="${repository.jvm.password.enabled}"/>
   </bean>
-  
+
-  <bean id="javax.jcr.Credentials.binaries" class="javax.jcr.SimpleCredentials">
-    <constructor-arg value="${binaries.repository.user.name}${repository.pool.user.name.separator}${binaries.repository.pool.name}"/>
+
+  <!-- hstconfigreader cred that can be used in delegating repository -->
+  <bean id="javax.jcr.Credentials.hstconfigreader.delegating" class="org.hippoecm.hst.core.jcr.SimpleCredentialsFactoryBean">
+    <constructor-arg value="${hstconfigreader.repository.user.name}"/>
+    <constructor-arg value="${hstconfigreader.repository.password}"/>
+    <constructor-arg value="${repository.jvm.password.enabled}"/>
+  </bean>
+
+  <bean id="javax.jcr.Credentials.binaries" class="org.hippoecm.hst.core.jcr.SimpleCredentialsFactoryBean">
+    <constructor-arg value="${binaries.repository.user.name}"/>
+    <constructor-arg value="${repository.pool.user.name.separator}"/>
+    <constructor-arg value="${binaries.repository.pool.name}"/>
     <constructor-arg value="${binaries.repository.password}"/>
+    <constructor-arg value="${repository.jvm.password.enabled}"/>
   </bean>
-  
+
   <bean id="defaultPoolingCounter" class="org.hippoecm.hst.core.jcr.pool.DefaultPoolingCounter" scope="prototype">
     <property name="enabled" value="${repository.pool.counter.enabled}" />
   </bean>
@@ -72,6 +104,7 @@
             <property name="defaultCredentialsUserID" value="${default.repository.user.name}${repository.pool.user.name.separator}${default.repository.pool.name}"/>
             <property name="defaultCredentialsUserIDSeparator" value="${repository.pool.user.name.separator}"/>
             <property name="defaultCredentialsPassword" value="${default.repository.password}"/>
+            <property name="jvmPasswordEnabled" value="${repository.jvm.password.enabled}"/>
             <!-- Pool properties. Refer to the GenericObjectPool of commons-pool library. -->
             <property name="maxActive" value="${default.repository.maxActive}"/>
             <property name="maxIdle" value="${default.repository.maxIdle}"/>
@@ -99,6 +132,7 @@
             <property name="defaultCredentialsUserID" value="${preview.repository.user.name}${repository.pool.user.name.separator}${preview.repository.pool.name}"/>
             <property name="defaultCredentialsUserIDSeparator" value="${repository.pool.user.name.separator}"/>
             <property name="defaultCredentialsPassword" value="${preview.repository.password}"/>
+            <property name="jvmPasswordEnabled" value="${repository.jvm.password.enabled}"/>
             <!-- Pool properties. Refer to the GenericObjectPool of commons-pool library. -->
             <property name="maxActive" value="${preview.repository.maxActive}"/>
             <property name="maxIdle" value="${preview.repository.maxIdle}"/>
@@ -127,6 +161,7 @@
             <property name="defaultCredentialsUserID" value="${writable.repository.user.name}${repository.pool.user.name.separator}${writable.repository.pool.name}"/>
             <property name="defaultCredentialsUserIDSeparator" value="${repository.pool.user.name.separator}"/>
             <property name="defaultCredentialsPassword" value="${writable.repository.password}"/>
+            <property name="jvmPasswordEnabled" value="${repository.jvm.password.enabled}"/>
             <!-- Pool properties. Refer to the GenericObjectPool of commons-pool library. -->
             <property name="maxActive" value="${writable.repository.maxActive}"/>
             <property name="maxIdle" value="${writable.repository.maxIdle}"/>
@@ -155,6 +190,7 @@
             <property name="defaultCredentialsUserID" value="${hstconfigreader.repository.user.name}${repository.pool.user.name.separator}${hstconfigreader.repository.pool.name}"/>
             <property name="defaultCredentialsUserIDSeparator" value="${repository.pool.user.name.separator}"/>
             <property name="defaultCredentialsPassword" value="${hstconfigreader.repository.password}"/>
+            <property name="jvmPasswordEnabled" value="${repository.jvm.password.enabled}"/>
             <!-- Pool properties. Refer to the GenericObjectPool of commons-pool library. -->
             <property name="maxActive" value="${hstconfigreader.repository.maxActive}"/>
             <property name="maxIdle" value="${hstconfigreader.repository.maxIdle}"/>
@@ -183,6 +219,7 @@
             <property name="defaultCredentialsUserID" value="${binaries.repository.user.name}${repository.pool.user.name.separator}${binaries.repository.pool.name}"/>
             <property name="defaultCredentialsUserIDSeparator" value="${repository.pool.user.name.separator}"/>
             <property name="defaultCredentialsPassword" value="${binaries.repository.password}"/>
+            <property name="jvmPasswordEnabled" value="${repository.jvm.password.enabled}"/>
             <!-- Pool properties. Refer to the GenericObjectPool of commons-pool library. -->
             <property name="maxActive" value="${binaries.repository.maxActive}"/>
             <property name="maxIdle" value="${binaries.repository.maxIdle}"/>
@@ -215,6 +252,8 @@
         <entry key="defaultCredentialsUserID" value="${default.repository.user.name}${repository.pool.user.name.separator}${default.repository.pool.name}"/>
         <entry key="defaultCredentialsUserIDSeparator" value="${repository.pool.user.name.separator}"/>
         <entry key="defaultCredentialsPassword" value="${default.repository.password}"/>
+        <entry key="jvmPasswordEnabled" value="${repository.jvm.password.enabled}"/>
+
         <!-- Pool properties. Refer to the GenericObjectPool of commons-pool library. -->
         
         <!-- Properties below are for lazy initialized pooling repositories. As there can be many of these, for example one per unique faceted navigation free text search 
Index: components/session-pool/pom.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- components/session-pool/pom.xml	(revision 45515)
+++ components/session-pool/pom.xml	(revision )
@@ -41,8 +41,14 @@
       <artifactId>hippo-repository-connector</artifactId>
       <scope>provided</scope>
     </dependency>
-    
+
     <dependency>
+      <groupId>org.onehippo.cms7</groupId>
+      <artifactId>hippo-cms7-commons</artifactId>
+      <scope>provided</scope>
+    </dependency>
+
+    <dependency>
       <groupId>commons-lang</groupId>
       <artifactId>commons-lang</artifactId>
     </dependency>
Index: components/core/src/test/java/org/hippoecm/hst/configuration/channel/ChannelPropertyMapperTest.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- components/core/src/test/java/org/hippoecm/hst/configuration/channel/ChannelPropertyMapperTest.java	(revision 45515)
+++ components/core/src/test/java/org/hippoecm/hst/configuration/channel/ChannelPropertyMapperTest.java	(revision )
@@ -24,6 +24,7 @@
 import javax.jcr.Node;
 import javax.jcr.Property;
 import javax.jcr.RepositoryException;
+import javax.jcr.SimpleCredentials;
 
 import org.hippoecm.hst.configuration.cache.HstNodeLoadingCache;
 import org.hippoecm.hst.core.parameters.Parameter;
@@ -104,8 +105,7 @@
         hstNodeLoadingCache = new HstNodeLoadingCache();
         hstNodeLoadingCache.setRepository(server.getRepository());
         hstNodeLoadingCache.setRootPath("/test");
-        hstNodeLoadingCache.setPassword("admin");
-        hstNodeLoadingCache.setUsername("admin");
+        hstNodeLoadingCache.setCredentials(new SimpleCredentials("admin", "admin".toCharArray()));
     }
 
     @Test
Index: components/core/src/main/java/org/hippoecm/hst/configuration/cache/HstNodeLoadingCache.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- components/core/src/main/java/org/hippoecm/hst/configuration/cache/HstNodeLoadingCache.java	(revision 45515)
+++ components/core/src/main/java/org/hippoecm/hst/configuration/cache/HstNodeLoadingCache.java	(revision )
@@ -20,6 +20,7 @@
 import java.util.HashSet;
 import java.util.Set;
 
+import javax.jcr.Credentials;
 import javax.jcr.Repository;
 import javax.jcr.RepositoryException;
 import javax.jcr.Session;
@@ -44,8 +45,7 @@
     private int rootPathLength;
     private HstNode rootNode;
     private Repository repository;
-    private String username;
-    private String password;
+    Credentials credentials;
 
     private Set<HstEvent> events;
 
@@ -54,14 +54,10 @@
         this.repository = repository;
     }
 
-    public void setUsername(String username) {
-        this.username = username;
+    public void setCredentials(final Credentials credentials) {
+        this.credentials = credentials;
     }
 
-    public void setPassword(String password) {
-        this.password = password;
-    }
-
     public void setRootPath(final String rootPath) {
         this.rootPath = rootPath;
         rootPathLength = rootPath.length();
@@ -191,7 +187,7 @@
                 return session;
             }
             try {
-                session = repository.login(new SimpleCredentials(username, password.toCharArray()));
+                session = repository.login(credentials);
             } catch (RepositoryException e) {
                 throw new ModelLoadingException("Repository exception while getting jcr session", e);
             }
Index: components/core/src/main/java/org/hippoecm/hst/core/jcr/SimpleCredentialsFactoryBean.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- components/core/src/main/java/org/hippoecm/hst/core/jcr/SimpleCredentialsFactoryBean.java	(revision )
+++ components/core/src/main/java/org/hippoecm/hst/core/jcr/SimpleCredentialsFactoryBean.java	(revision )
@@ -0,0 +1,61 @@
+/*
+ *  Copyright 2014 Hippo B.V. (http://www.onehippo.com)
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *       http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.hippoecm.hst.core.jcr;
+
+import javax.jcr.SimpleCredentials;
+
+import org.onehippo.cms7.security.JvmJcrUsers;
+import org.springframework.beans.factory.config.AbstractFactoryBean;
+
+public class SimpleCredentialsFactoryBean extends AbstractFactoryBean<SimpleCredentials> {
+
+    final String userId;
+    final char[] password;
+    final String separator;
+    final String poolName;
+
+
+    @SuppressWarnings("UnusedDeclaration")
+    public SimpleCredentialsFactoryBean(final String userId, final char[] password, final boolean jvmPasswordEnabled) {
+        this(userId, null, null, password, jvmPasswordEnabled);
+    }
+
+    public SimpleCredentialsFactoryBean(final String userId, final String separator, final String poolName,
+                                        final char[] password, final boolean jvmPasswordEnabled) {
+        this.userId = userId;
+        this.separator = separator;
+        this.poolName = poolName;
+        if (jvmPasswordEnabled && (password == null || password.length == 0)) {
+            final SimpleCredentials jvmCredentials = JvmJcrUsers.getJvmCredentials(userId);
+            this.password = jvmCredentials.getPassword();
+        } else {
+            this.password = password;
+        }
+    }
+
+    @Override
+    public Class<?> getObjectType() {
+        return SimpleCredentials.class;
+    }
+
+    @Override
+    protected SimpleCredentials createInstance() throws Exception {
+        if (separator != null && poolName != null) {
+           return new SimpleCredentials(userId + separator + poolName, password);
+        }
+        return new SimpleCredentials(userId, password);
+    }
+}
Index: components/core/src/main/resources/org/hippoecm/hst/site/container/SpringComponentManager-hstManager.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- components/core/src/main/resources/org/hippoecm/hst/site/container/SpringComponentManager-hstManager.xml	(revision 45515)
+++ components/core/src/main/resources/org/hippoecm/hst/site/container/SpringComponentManager-hstManager.xml	(revision )
@@ -53,8 +53,7 @@
 
   <bean id="org.hippoecm.hst.configuration.cache.HstNodeLoadingCache"  class="org.hippoecm.hst.configuration.cache.HstNodeLoadingCache">
     <property name="repository" ref="javax.jcr.Repository.delegating" />
-    <property name="username" value="${hstconfigreader.repository.user.name}" />
-    <property name="password" value="${hstconfigreader.repository.password}" />
+    <property name="credentials" ref="javax.jcr.Credentials.hstconfigreader.delegating"/>
     <property name="rootPath" value="${hst.configuration.rootPath}"/>
   </bean>
 
@@ -69,7 +68,6 @@
     <property name="hstEventsCollector" ref="hstEventsCollector"/>
     <property name="hstManager" ref="org.hippoecm.hst.configuration.model.HstManager"/>
   </bean>
-
 
 
   <bean id="org.hippoecm.hst.configuration.model.HstManager" class="org.hippoecm.hst.configuration.model.HstManagerImpl">
Index: components/core/src/main/resources/org/hippoecm/hst/site/container/SpringComponentManager.properties
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- components/core/src/main/resources/org/hippoecm/hst/site/container/SpringComponentManager.properties	(revision 45515)
+++ components/core/src/main/resources/org/hippoecm/hst/site/container/SpringComponentManager.properties	(revision )
@@ -39,6 +39,13 @@
 # Setting the value lower reduces memory, but also reduces performance
 lazySession.maxRefreshIntervalOnCleanup = 300000
 
+repository.jvm.password.enabled = false
+hstconfigreader.repository.password =
+binaries.repository.password =
+default.repository.password =
+preview.repository.password =
+writable.repository.password =
+
 # default session pool sizes:
 hstconfigreader.repository.maxActive = 25
 hstconfigreader.repository.maxIdle = 5
@@ -51,14 +58,6 @@
 binaries.repository.maxActive = 100
 binaries.repository.maxIdle = 10
 
-# the global user that should be able to read all configuration and retrieve all events
-hstconfigreader.repository.address =
-hstconfigreader.repository.user.name = admin
-hstconfigreader.repository.pool.name = hstconfigreader
-hstconfigreader.repository.password = admin
-binaries.repository.user.name = admin
-binaries.repository.pool.name = binaries
-binaries.repository.password = admin
 
 hst.configuration.rootPath = /hst:hst
 
@@ -142,4 +141,5 @@
 
 cms.preview.security.delegation.enabled = true
 
-object.converter.caching = true
\ No newline at end of file
+object.converter.caching = true
+
Index: components/session-pool/src/main/java/org/hippoecm/hst/core/jcr/pool/BasicPoolingRepositoryFactory.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- components/session-pool/src/main/java/org/hippoecm/hst/core/jcr/pool/BasicPoolingRepositoryFactory.java	(revision 45515)
+++ components/session-pool/src/main/java/org/hippoecm/hst/core/jcr/pool/BasicPoolingRepositoryFactory.java	(revision )
@@ -118,6 +118,8 @@
                 poolingRepository.setDefaultCredentialsUserIDSeparator(value);
             } else if (type.equals("defaultCredentialsPassword")) {
                 poolingRepository.setDefaultCredentialsPassword(value.toCharArray());
+            } else if (type.equals("jvmPasswordEnabled")) {
+                poolingRepository.setJvmPasswordEnabled(Boolean.parseBoolean(value));
             } else if (type.equals("defaultWorkspaceName")) {
                 poolingRepository.setDefaultWorkspaceName(value);
             } else if (type.equals("maxActive")) {
@@ -153,7 +155,8 @@
             }
         }
         
-        poolingRepository.setDefaultCredentials(new SimpleCredentials(poolingRepository.getDefaultCredentialsUserID(), poolingRepository.getDefaultCredentialsPassword()));
+        poolingRepository.setDefaultCredentials(new SimpleCredentials(poolingRepository.getDefaultCredentialsUserID(),
+                poolingRepository.getDefaultCredentialsPassword()));
         
         poolingRepository.initialize();
         
Index: components/session-pool/src/main/java/org/hippoecm/hst/core/jcr/pool/BasicPoolingRepository.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- components/session-pool/src/main/java/org/hippoecm/hst/core/jcr/pool/BasicPoolingRepository.java	(revision 45515)
+++ components/session-pool/src/main/java/org/hippoecm/hst/core/jcr/pool/BasicPoolingRepository.java	(revision )
@@ -32,6 +32,7 @@
 import org.apache.commons.pool.PoolableObjectFactory;
 import org.apache.commons.pool.impl.GenericObjectPool;
 import org.hippoecm.hst.core.ResourceLifecycleManagement;
+import org.onehippo.cms7.security.JvmJcrUsers;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
@@ -61,6 +62,7 @@
     private String defaultCredentialsUserID;
     private String defaultCredentialsUserIDSeparator = String.valueOf('\uFFFF');
     private char [] defaultCredentailsPassword;
+    private boolean jvmPasswordEnabled;
     private String defaultWorkspaceName;
 
     private long maxTimeToLiveMillis;
@@ -121,10 +123,14 @@
             String userIDOnly = StringUtils.substringBefore(userID, defaultCredentialsUserIDSeparator);
             
             if (!userID.equals(userIDOnly)) {
+                if (jvmPasswordEnabled) {
+                    internalDefaultCredentials = JvmJcrUsers.getJvmCredentials(userIDOnly);
+                } else {
-                internalDefaultCredentials = new SimpleCredentials(userIDOnly, ((SimpleCredentials) defaultCredentials).getPassword());
-            }
-        }
-    }
+                    internalDefaultCredentials = new SimpleCredentials(userIDOnly, ((SimpleCredentials) defaultCredentials).getPassword());
+                }
+            }
+        }
+    }
 
     public Credentials getDefaultCredentials() {
         return this.defaultCredentials;
@@ -154,7 +160,7 @@
             System.arraycopy(defaultCredentailsPassword, 0, this.defaultCredentailsPassword, 0, defaultCredentailsPassword.length);
         }
     }
-    
+
     public char [] getDefaultCredentialsPassword() {
         if (defaultCredentailsPassword == null) {
             return null;
@@ -163,8 +169,12 @@
         char [] value = new char[defaultCredentailsPassword.length];
         System.arraycopy(defaultCredentailsPassword, 0, value, 0, defaultCredentailsPassword.length);
         return value;
+    }
+
+    public void setJvmPasswordEnabled(boolean jvmPasswordEnabled) {
+        this.jvmPasswordEnabled = jvmPasswordEnabled;
     }
-    
+
     public void setDefaultWorkspaceName(String defaultWorkspaceName) {
         this.defaultWorkspaceName = defaultWorkspaceName;
     }
Index: components/core/src/test/java/org/hippoecm/hst/configuration/channel/BlueprintHandlerTest.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- components/core/src/test/java/org/hippoecm/hst/configuration/channel/BlueprintHandlerTest.java	(revision 45515)
+++ components/core/src/test/java/org/hippoecm/hst/configuration/channel/BlueprintHandlerTest.java	(revision )
@@ -16,6 +16,7 @@
 package org.hippoecm.hst.configuration.channel;
 
 import javax.jcr.RepositoryException;
+import javax.jcr.SimpleCredentials;
 
 import org.hippoecm.hst.configuration.HstNodeTypes;
 import org.hippoecm.hst.configuration.cache.HstNodeLoadingCache;
@@ -43,8 +44,7 @@
         hstNodeLoadingCache = new HstNodeLoadingCache();
         hstNodeLoadingCache.setRepository(server.getRepository());
         hstNodeLoadingCache.setRootPath("/test");
-        hstNodeLoadingCache.setPassword("admin");
-        hstNodeLoadingCache.setUsername("admin");
+        hstNodeLoadingCache.setCredentials(new SimpleCredentials("admin", "admin".toCharArray()));
     }
 
     /**