Index: perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/admin/groups/Group.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/admin/groups/Group.java	(revision 54341)
+++ perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/admin/groups/Group.java	(revision )
@@ -18,8 +18,10 @@
 
 import java.util.ArrayList;
 import java.util.Collections;
+import java.util.Iterator;
 import java.util.List;
 import java.util.Map;
+
 import javax.jcr.Node;
 import javax.jcr.NodeIterator;
 import javax.jcr.RepositoryException;
@@ -29,13 +31,15 @@
 import javax.jcr.query.QueryResult;
 
 import org.apache.jackrabbit.util.ISO9075;
-import org.apache.wicket.util.io.IClusterable;
 import org.apache.jackrabbit.util.Text;
 import org.apache.wicket.Session;
+import org.apache.wicket.util.io.IClusterable;
 import org.hippoecm.frontend.plugins.cms.admin.domains.Domain;
 import org.hippoecm.frontend.plugins.cms.admin.permissions.PermissionBean;
 import org.hippoecm.frontend.plugins.cms.admin.users.DetachableUser;
+import org.hippoecm.frontend.plugins.cms.admin.users.SystemUserDataProvider;
 import org.hippoecm.frontend.plugins.cms.admin.users.User;
+import org.hippoecm.frontend.plugins.cms.admin.users.UserDataProvider;
 import org.hippoecm.frontend.session.UserSession;
 import org.hippoecm.repository.api.HippoNodeType;
 import org.hippoecm.repository.api.NodeNameCodec;
@@ -230,31 +234,41 @@
      * @throws RepositoryException
      */
     public List<String> getMembers() throws RepositoryException {
-        return getMembers(false);
+        return getMembers(true);
     }
 
-    private List<String> getMembers(boolean includeSystemUsers) throws RepositoryException {
-        final List<String> members = new ArrayList<String>();
+    private List<String> getMembers(boolean excludeSystemUsers) throws RepositoryException {
+        final List<String> members = new ArrayList<>();
         if (node.hasProperty(HippoNodeType.HIPPO_MEMBERS)) {
-            final Value[] vals = node.getProperty(HippoNodeType.HIPPO_MEMBERS).getValues();
-            for (Value val : vals) {
-                final String username = val.getString();
-                if (!includeSystemUsers && User.userExists(username)) {
-                    final User user = new User(username);
-                    if (user.isSystemUser()) {
+            final Value[] groupUsers = node.getProperty(HippoNodeType.HIPPO_MEMBERS).getValues();
+
+            UserDataProvider systemUsersDataProvider = new SystemUserDataProvider();
+            List<String> systemUsers = new ArrayList<>();
+
+            Iterator<User> systemUsersIterator = systemUsersDataProvider.iterator(0, systemUsersDataProvider.size());
+            while (systemUsersIterator.hasNext()) {
+                String systemUserName = systemUsersIterator.next().getUsername();
+                systemUsers.add(systemUserName);
+            }
+
+            for (Value val : groupUsers) {
+                final String userName = val.getString();
+
+                if (excludeSystemUsers && systemUsers.contains(userName)) {
-                        continue;
-                    }
+                    continue;
+                }
+
+                members.add(userName);
-                }
+            }
-                members.add(username);
+
-            }
+        }
-        }
         Collections.sort(members);
         return members;
 
     }
 
     private List<String> getAllMembers() throws RepositoryException {
-        return getMembers(true);
+        return getMembers(false);
     }
 
     public List<DetachableUser> getMembersAsDetachableUsers() {
Index: perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/admin/users/SystemUserDataProvider.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/admin/users/SystemUserDataProvider.java	(revision )
+++ perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/admin/users/SystemUserDataProvider.java	(revision )
@@ -0,0 +1,19 @@
+package org.hippoecm.frontend.plugins.cms.admin.users;
+
+import org.apache.wicket.extensions.markup.html.repeater.data.sort.SortOrder;
+import org.hippoecm.repository.api.HippoNodeType;
+
+/**
+ */
+public class SystemUserDataProvider extends UserDataProvider {
+
+    private static final String QUERY_SYSTEM_USER_LIST = "SELECT * " +
+            " FROM " + HippoNodeType.NT_USER
+            +" WHERE hipposys:system = 'true'";
+
+    public SystemUserDataProvider() {
+        super(QUERY_SYSTEM_USER_LIST, QUERY_SYSTEM_USER_LIST, "/hippo:configuration/hippo:users", HippoNodeType.NT_USER, HippoNodeType.NT_USERFOLDER);
+        setSort("username", SortOrder.ASCENDING);
+    }
+
+}
Index: perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/admin/users/UserDataProvider.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/admin/users/UserDataProvider.java	(revision 54341)
+++ perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/admin/users/UserDataProvider.java	(revision )
@@ -53,6 +53,10 @@
         setSort("username", SortOrder.ASCENDING);
     }
 
+    public UserDataProvider(String searchAllSqlStatement, String searchTermSqlStatementTemplate, String observePath, String... observeNodeTypes) {
+        super(searchAllSqlStatement, searchTermSqlStatementTemplate, observePath, observeNodeTypes);
+    }
+
     @Override
     public IModel<User> model(final User user) {
         return new DetachableUser(user);