Index: ../cms-trunk/perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/dashboard/todo/TodoPlugin.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- ../cms-trunk/perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/dashboard/todo/TodoPlugin.java	(revision 57054)
+++ ../cms-trunk/perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/dashboard/todo/TodoPlugin.java	(revision )
@@ -16,6 +16,7 @@
 package org.hippoecm.frontend.plugins.cms.dashboard.todo;
 
 import java.io.Serializable;
+import java.util.Calendar;
 import java.util.Iterator;
 
 import javax.jcr.Node;
@@ -37,6 +38,8 @@
 
 public class TodoPlugin extends RenderPlugin {
 
+    private static final long serialVersionUID = 1L;
+
     private static final Logger log = LoggerFactory.getLogger(TodoPlugin.class);
 
     public TodoPlugin(IPluginContext context, IPluginConfig config) {
@@ -74,7 +77,8 @@
                 final Request request = new Request(nodeModel, this);
                 item.add(new TodoLink(getPluginContext(), getPluginConfig(), "link", target,
                         new PropertyModel<>(request, "username"),
-                        new PropertyModel<>(request, "localType")));
+                        new PropertyModel<>(request, "localType"),
+                        new PropertyModel<>(request, "creationDate")));
             } catch (RepositoryException e) {
                 log.error("Failed to create todo item from publication request node", e);
             }
@@ -83,6 +87,8 @@
 
     private static class Request implements Serializable {
 
+        private static final long serialVersionUID = 1L;
+
         private final IModel<Node> nodeModel;
         private final Component container;
 
@@ -107,6 +113,23 @@
                 Node node = nodeModel.getObject();
                 return node.getProperty(HippoStdPubWfNodeType.HIPPOSTDPUBWF_USERNAME).getString();
             } catch (RepositoryException ignored) {
+            }
+            return null;
+        }
+
+        /**
+         * Get the creation date of the request. Returns a {@link java.util.Calendar} object when a
+         * date is available, null otherwise.
+         * @return the creation date or null
+         */
+        public Calendar getCreationDate() {
+            try {
+                Node node = nodeModel.getObject();
+                if(node.hasProperty(HippoStdPubWfNodeType.HIPPOSTDPUBWF_CREATION_DATE)) {
+                    return node.getProperty(HippoStdPubWfNodeType.HIPPOSTDPUBWF_CREATION_DATE).getDate();
+                }
+            } catch (RepositoryException e) {
+                log.warn("Error while retrieving creation date", e);
             }
             return null;
         }
Index: ../cms-trunk/perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/dashboard/todo/TodoLink.html
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- ../cms-trunk/perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/dashboard/todo/TodoLink.html	(revision 57054)
+++ ../cms-trunk/perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/dashboard/todo/TodoLink.html	(revision )
@@ -17,6 +17,7 @@
   <wicket:panel>
     <a class="browse-link" wicket:id="link">
       <div class="browse-link-label">
+        <span wicket:id="creationDate">creationDate</span>
         <span wicket:id="username">username</span>
         <span wicket:id="operation">operation</span>
         <div wicket:id="document">document</div>
Index: ../cms-trunk/perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/dashboard/todo/TodoLink.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- ../cms-trunk/perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/dashboard/todo/TodoLink.java	(revision 57054)
+++ ../cms-trunk/perspectives/src/main/java/org/hippoecm/frontend/plugins/cms/dashboard/todo/TodoLink.java	(revision )
@@ -15,11 +15,16 @@
  */
 package org.hippoecm.frontend.plugins.cms.dashboard.todo;
 
+import java.text.DateFormat;
+import java.util.Calendar;
+
+import org.apache.commons.lang.StringUtils;
 import org.apache.wicket.ajax.AjaxRequestTarget;
 import org.apache.wicket.ajax.markup.html.AjaxLink;
 import org.apache.wicket.markup.html.basic.Label;
 import org.apache.wicket.markup.html.panel.Panel;
 import org.apache.wicket.model.IModel;
+import org.apache.wicket.model.Model;
 import org.apache.wicket.model.PropertyModel;
 import org.hippoecm.frontend.model.JcrNodeModel;
 import org.hippoecm.frontend.plugin.IPluginContext;
@@ -33,11 +38,45 @@
 
 public class TodoLink extends Panel {
 
+    private static final long serialVersionUID = 1L;
+
     private static final Logger log = LoggerFactory.getLogger(TodoLink.class);
 
+    private final DateFormat dateFormatShort = DateFormat.getDateInstance(DateFormat.MEDIUM,
+            getSession().getLocale());
+
+    /**
+     * Constructor of a to do link.
+     * @param context the plugin context
+     * @param config the plugin config
+     * @param id the id
+     * @param browseLinkTarget the link target
+     * @param userLabelModel the user label
+     * @param operationLabelModel the operation label
+     * @deprecated As of release 3.2.0, replaced by
+     * {@link #TodoLink(IPluginContext, IPluginConfig, String, BrowseLinkTarget, IModel, IModel, IModel)}
+     */
+    @Deprecated
     public TodoLink(final IPluginContext context, final IPluginConfig config,
                     final String id, final BrowseLinkTarget browseLinkTarget,
                     final IModel<String> userLabelModel, final IModel<String> operationLabelModel) {
+        this(context, config, id, browseLinkTarget, userLabelModel, operationLabelModel, null);
+    }
+
+    /**
+     * Constructor of a to do link.
+     * @param context the plugin context
+     * @param config the plugin config
+     * @param id the id
+     * @param browseLinkTarget the link target
+     * @param userLabelModel the user label
+     * @param operationLabelModel the operation label
+     * @param creationDateModel the creation date
+     */
+    public TodoLink(final IPluginContext context, final IPluginConfig config,
+                    final String id, final BrowseLinkTarget browseLinkTarget,
+                    final IModel<String> userLabelModel, final IModel<String> operationLabelModel,
+                    final IModel<Calendar> creationDateModel) {
         super(id);
 
         AjaxLink<Void> link = new AjaxLink<Void>("link") {
@@ -70,6 +109,11 @@
         Label operationLabel = new Label("operation", operationLabelModel);
         operationLabel.setEscapeModelStrings(false);
         link.add(operationLabel);
+
+        // Set the creation date or an empty string when no creation date is available
+        final String creationDate = creationDateModel != null && creationDateModel.getObject() != null ?
+                dateFormatShort.format(creationDateModel.getObject().getTime()) : StringUtils.EMPTY;
+        link.add(new Label("creationDate", new Model<>(creationDate)));
 
         Label documentLabel = new Label("document", "\"" + browseLinkTarget.getName() + "\"");
         link.add(documentLabel);
Index: ../cms-trunk/config/src/main/resources/cms-reports.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- ../cms-trunk/config/src/main/resources/cms-reports.xml	(revision 57054)
+++ ../cms-trunk/config/src/main/resources/cms-reports.xml	(revision )
@@ -145,7 +145,7 @@
       </sv:property>
       <sv:property sv:name="jcr:statement" sv:type="String">
         <!-- As per request of HREPTWO-3159 also display rejected requests -->
-        <sv:value>SELECT * FROM hippostdpubwf:request WHERE NOT hippostdpubwf:type = 'rejected' OR hippostdpubwf:username='__USER__'</sv:value>
+        <sv:value>SELECT * FROM hippostdpubwf:request WHERE NOT hippostdpubwf:type = 'rejected' OR hippostdpubwf:username='__USER__' ORDER BY hippostdpubwf:creationDate DESC</sv:value>
       </sv:property>
     </sv:node>
   </sv:node>
Index: ../cms-trunk/config/src/main/resources/hippoecm-extension.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- ../cms-trunk/config/src/main/resources/hippoecm-extension.xml	(revision 57054)
+++ ../cms-trunk/config/src/main/resources/hippoecm-extension.xml	(revision )
@@ -411,7 +411,7 @@
       <sv:value>true</sv:value>
     </sv:property>
     <sv:property sv:name="hippo:version" sv:type="String">
-      <sv:value>2.25.03</sv:value>
+      <sv:value>3.2.0</sv:value>
     </sv:property>
   </sv:node>
   <!-- CMS browser perspective -->